'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var ease = _interopDefault(require('rx-ease'));
var rxjs = require('rxjs');
require('rxjs/operators');

var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



































var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var curry = function curry(f) {
  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return args.length >= f.length ? f.apply(undefined, args) : function () {
      for (var _len4 = arguments.length, args2 = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args2[_key4] = arguments[_key4];
      }

      return curry(f).apply(undefined, args.concat(args2));
    };
  };
};

var isObservable = function isObservable(x) {
  return x && typeof x.subscribe === 'function';
};

var toObservable = function toObservable(x) {
  return isObservable(x) ? x : rxjs.of(x);
};



var all = function all(obs) {
  return obs.length ? rxjs.combineLatest.apply(undefined, toConsumableArray(obs.map(toObservable)).concat([function () {
    for (var _len = arguments.length, xs = Array(_len), _key = 0; _key < _len; _key++) {
      xs[_key] = arguments[_key];
    }

    return xs;
  }])) : rxjs.of([]);
};



var raf = new rxjs.Observable(function (observer) {
  var isSubscribed = true;

  var loop = function loop() {
    if (isSubscribed) {
      observer.next();
      window.requestAnimationFrame(loop);
    }
  };

  window.requestAnimationFrame(loop);

  return {
    unsubscribe: function unsubscribe() {
      isSubscribed = false;
    }
  };
});

var mapValues = curry(function (f, obj) {
  return Object.keys(obj).reduce(function (acc, k) {
    return _extends({}, acc, defineProperty({}, k, f(obj[k], k)));
  }, {});
});

var createMutable = function createMutable(initialValue) {
  var sub = new rxjs.BehaviorSubject(initialValue);
  sub.set = function (x) {
    return sub.next(typeof x === 'function' ? x(sub.value) : x);
  };
  return sub;
};

function createState(initialState) {
  return mapValues(createMutable, initialState);
}

exports.ease = ease;
exports.createState = createState;
exports.all = all;
