'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var createTag = _interopDefault(require('vdom-tag'));
var rxjs = require('rxjs');
var operators = require('rxjs/operators');

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};





















var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();











var toArray = function (arr) {
  return Array.isArray(arr) ? arr : Array.from(arr);
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var compose = function compose() {
  for (var _len = arguments.length, fns = Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function (x) {
    return fns.reduceRight(function (value, f) {
      return f(value);
    }, x);
  };
};



var curry = function curry(f) {
  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return args.length >= f.length ? f.apply(undefined, args) : function () {
      for (var _len4 = arguments.length, args2 = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args2[_key4] = arguments[_key4];
      }

      return curry(f).apply(undefined, args.concat(args2));
    };
  };
};

var isPromise = function isPromise(p) {
  return p && typeof p.then === 'function';
};

var isObservable = function isObservable(x) {
  return x && typeof x.subscribe === 'function';
};

var toObservable = function toObservable(x) {
  return isObservable(x) ? x : rxjs.of(x);
};

var switchMap = curry(function (switchMapper, stream) {
  var subscription = void 0;

  return new rxjs.Observable(function (observer) {
    var isOuterStreamComplete = false;
    var isInnerStreamComplete = false;

    var sub = stream.subscribe({
      next: function next(x) {
        if (subscription) subscription.unsubscribe();
        subscription = switchMapper(x).subscribe({
          error: function error(e) {
            return observer.error(e);
          },
          next: function next(x) {
            return observer.next(x);
          },
          complete: function complete() {
            isInnerStreamComplete = true;
            if (isOuterStreamComplete) observer.complete();
          }
        });
      },
      error: function error(e) {
        return observer.error(e);
      },
      complete: function complete() {
        isOuterStreamComplete = true;
        if (isInnerStreamComplete) observer.complete();
      }
    });

    return {
      unsubscribe: function unsubscribe() {
        if (subscription) subscription.unsubscribe();
        sub.unsubscribe();
      }
    };
  });
});

var all = function all(obs) {
  return obs.length ? rxjs.combineLatest.apply(undefined, toConsumableArray(obs.map(toObservable)).concat([function () {
    for (var _len = arguments.length, xs = Array(_len), _key = 0; _key < _len; _key++) {
      xs[_key] = arguments[_key];
    }

    return xs;
  }])) : rxjs.of([]);
};

var blockComplete = function blockComplete() {
  return function (stream) {
    return new rxjs.Observable(function (observer) {
      return stream.subscribe({
        complete: function complete() {},
        next: function next(x) {
          return observer.next(x);
        },
        error: function error(e) {
          return observer.error(e);
        }
      });
    });
  };
};

var raf = new rxjs.Observable(function (observer) {
  var isSubscribed = true;

  var loop = function loop() {
    if (isSubscribed) {
      observer.next();
      window.requestAnimationFrame(loop);
    }
  };

  window.requestAnimationFrame(loop);

  return {
    unsubscribe: function unsubscribe() {
      isSubscribed = false;
    }
  };
});

var noOp = function noOp() {};

var createDefaultLifecycle = function createDefaultLifecycle() {
  return {
    mount: noOp,
    update: noOp,
    unmount: noOp
  };
};

var isEmpty = function isEmpty(x) {
  return x !== 0 && (!x || typeof x === 'string' && !x.trim());
};

var hasContent = function hasContent(xs) {
  return !xs.length || !xs.every(isEmpty);
};

// data Variable a
//   = a
//   | Promise (Variable a)
//   | Observable (Variable a)
//   | [Variable a]

// flatten :: Variable a -> Observable a
var flatten = function flatten(variable) {
  return Array.isArray(variable) ? all(variable.map(compose(operators.startWith(''), flatten))).pipe(blockComplete(), operators.filter(hasContent)) : isObservable(variable) ? switchMap(flatten, variable) : isPromise(variable) ? switchMap(flatten, rxjs.from(variable)) : toObservable(variable);
};

var sharedRaf = operators.share()(raf);

// createReactiveTag
//  :: ([String] -> ...[Variable a] -> b)
//  -> [String]
//  -> ...[Variable a]
//  -> Observable b
var createReactiveTag = function createReactiveTag(tagFunction) {
  return function (strings) {
    for (var _len = arguments.length, variables = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      variables[_key - 1] = arguments[_key];
    }

    return flatten(variables).pipe(operators.startWith([]), operators.sample(sharedRaf), operators.map(function (variables) {
      return tagFunction.apply(undefined, [strings].concat(toConsumableArray(variables)));
    }));
  };
};

function _objectEntries(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

function _objectEntries(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

function updateStyle(node) {
  var previousStyle = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var nextStyle = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  for (var key in _extends({}, previousStyle, nextStyle)) {
    var style = !nextStyle || !nextStyle[key] ? '' : nextStyle[key];
    if (nextStyle[key] === previousStyle[key]) {
      // no update needed
    } else if (key[0] === '-') {
      node.style.setProperty(key, style);
    } else {
      node.style[key] = style;
    }
  }
}

var VNode = function () {
  function VNode(_ref) {
    var name = _ref.name,
        _ref$attrs = _ref.attrs,
        attrs = _ref$attrs === undefined ? {} : _ref$attrs,
        _ref$lifecycle = _ref.lifecycle,
        lifecycle = _ref$lifecycle === undefined ? {} : _ref$lifecycle,
        _ref$events = _ref.events,
        events = _ref$events === undefined ? {} : _ref$events,
        _ref$children = _ref.children,
        children = _ref$children === undefined ? {} : _ref$children,
        _ref$key = _ref.key,
        key = _ref$key === undefined ? '' : _ref$key;
    classCallCheck(this, VNode);

    this.name = name;
    this.attrs = attrs;
    this.lifecycle = lifecycle;
    this.events = events;
    this.children = children;
    this.key = key;
  }

  createClass(VNode, [{
    key: 'createElement',
    value: function createElement(isSvg, patch, context) {
      var node = (isSvg = isSvg || this.name === 'svg') ? document.createElementNS('http://www.w3.org/2000/svg', this.name) : document.createElement(this.name);

      this.updateEvents(node, {});
      this.updateAttrs(node, {});
      this.updateChildren(node, [], isSvg, patch, context);

      return node;
    }
  }, {
    key: 'updateElement',
    value: function updateElement(node, previousTree, isSvg, patch, context) {
      if (previousTree.name !== this.name) {
        previousTree.removeElement(node);
        return this.createElement(isSvg, patch, context);
      } else {
        this.updateEvents(node, previousTree.events);
        this.updateAttrs(node, previousTree.attrs);
        this.updateChildren(node, previousTree.children, isSvg, patch, context);

        this.lifecycle.update(node);
      }
    }
  }, {
    key: 'removeElement',
    value: function removeElement(node) {
      this.children.map(function (child, index) {
        return child.removeElement(node.childNodes[index]);
      });

      this.lifecycle.unmount(node);
    }
  }, {
    key: 'mount',
    value: function mount(node) {
      this.children.map(function (child) {
        return child.mount();
      });

      this.lifecycle.mount(node);
    }
  }, {
    key: 'updateEvents',
    value: function updateEvents(node, previousEvents) {
      var _this = this;

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = _objectEntries(this.events)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref2 = _step.value;

          var _ref3 = slicedToArray(_ref2, 2);

          var eventName = _ref3[0];
          var handler = _ref3[1];

          if (!previousEvents[eventName]) {
            node.addEventListener(eventName, handler);
          } else if (handler !== previousEvents[eventName]) {
            node.removeEventListener(eventName, previousEvents[eventName]);
            node.addEventListener(eventName, handler);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var removedEventsEntries = _objectEntries(previousEvents).filter(function (_ref4) {
        var _ref5 = slicedToArray(_ref4, 1),
            key = _ref5[0];

        return !_this.events[key];
      });

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = removedEventsEntries[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _ref6 = _step2.value;

          var _ref7 = slicedToArray(_ref6, 2);

          var _eventName = _ref7[0];
          var _handler = _ref7[1];

          node.removeEventListener(_eventName, _handler);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
  }, {
    key: 'updateAttrs',
    value: function updateAttrs(node, previousAttrs) {
      for (var attrName in _extends({}, previousAttrs, this.attrs)) {
        var attrValue = this.attrs[attrName];

        if (attrValue === previousAttrs[attrName]) {
          // no update needed
        } else if (!isEmpty(attrValue)) {
          if (attrName === 'style') {
            updateStyle(node, previousAttrs.style, this.attrs.style);
          } else if (attrName === 'value' && node.tagName === 'INPUT') {
            node.value = attrValue;
          } else {
            node.setAttribute(attrName, attrValue);
          }
        } else {
          if (attrName === 'value' && node.tagName === 'INPUT') {
            node.value = '';
          } else {
            node.removeAttribute(attrName);
          }
        }
      }
    }
  }, {
    key: 'updateChildren',
    value: function updateChildren(node, previousChildren, isSvg, patch, context) {
      for (var index in this.children) {
        var childTree = this.children[index];
        var previousChildTree = previousChildren[index];
        var previousChildNode = node.childNodes[index];

        if (!previousChildNode) {
          var childNode = childTree.createElement(isSvg, patch, context);
          node.appendChild(childNode);
          childTree.mount(childNode);
        } else {
          patch(previousChildNode, previousChildTree, childTree, isSvg, context);
        }
      }

      for (var _index in [].slice.call(node.childNodes, this.children.length)) {
        var realIndex = parseInt(_index) + this.children.length;
        var _childTree = previousChildren[realIndex];
        var _childNode = node.childNodes[realIndex];
        if (_childNode) {
          _childTree.removeElement(_childNode);
          _childNode.remove();
        }
      }
    }
  }]);
  return VNode;
}();

var VText = function () {
  function VText(_ref) {
    var text = _ref.text;
    classCallCheck(this, VText);

    this.text = text;
  }

  createClass(VText, [{
    key: "createElement",
    value: function createElement() {
      return document.createTextNode(this.text);
    }
  }, {
    key: "updateElement",
    value: function updateElement(node, previousText) {
      if (previousText.text !== this.text) node.textContent = this.text;
    }
  }, {
    key: "removeElement",
    value: function removeElement() {}
  }, {
    key: "mount",
    value: function mount() {}
  }]);
  return VText;
}();

function createVTree(node) {
  return new VNode({
    name: node.nodeName.toLowerCase(),
    lifecycle: createDefaultLifecycle(),
    events: {},
    attrs: {},
    untouchedAttributes: {},
    children: Array.prototype.map.call(node.childNodes, function (node) {
      return node.nodeType === 3 // Node.TEXT_NODE
      ? new VText({ text: node.nodeValue }) : createVTree(node);
    })
  });
}

function patch(node) {
  var previousTree = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : createVTree(node);
  var vTree = arguments[2];
  var isSvg = arguments[3];
  var context = arguments[4];

  if (vTree.constructor !== previousTree.constructor || vTree.key !== previousTree.key) {
    previousTree.removeElement(node);
    var newNode = vTree.createElement(isSvg, patch, context);
    node.parentNode.replaceChild(newNode, node);
    vTree.mount(newNode);
    return newNode;
  } else {
    var _newNode = vTree.updateElement(node, previousTree, isSvg, patch, context);
    if (_newNode) {
      node.parentNode.replaceChild(_newNode, node);
      vTree.mount(_newNode, isSvg);
      return _newNode;
    } else {
      return node;
    }
  }
}

var VPatch = function () {
  function VPatch(vTree) {
    classCallCheck(this, VPatch);

    this.vTree = vTree;
  }

  createClass(VPatch, [{
    key: "createElement",
    value: function createElement() {
      var _vTree;

      return (_vTree = this.vTree).createElement.apply(_vTree, arguments);
    }
  }, {
    key: "updateElement",
    value: function updateElement() {
      var _vTree2;

      return (_vTree2 = this.vTree).updateElement.apply(_vTree2, arguments);
    }
  }, {
    key: "removeElement",
    value: function removeElement() {
      var _vTree3;

      return (_vTree3 = this.vTree).removeElement.apply(_vTree3, arguments);
    }
  }, {
    key: "mount",
    value: function mount() {
      var _vTree4;

      return (_vTree4 = this.vTree).mount.apply(_vTree4, arguments);
    }
  }]);
  return VPatch;
}();

function createPropsStream(props) {
  var sub = new rxjs.BehaviorSubject(props);
  return {
    next: function next(props) {
      return sub.next(props);
    },
    stream: sub
  };
}

var Component = function () {
  function Component(_ref) {
    var name = _ref.name,
        untouchedAttributes = _ref.untouchedAttributes,
        _ref$key = _ref.key,
        key = _ref$key === undefined ? '' : _ref$key;
    classCallCheck(this, Component);

    this.name = name;
    this.untouchedAttributes = untouchedAttributes;
    this.key = key;
  }

  createClass(Component, [{
    key: 'createElement',
    value: function createElement(isSvg, patch, context) {
      var _this = this;

      var node = isSvg ? document.createElementNS('http://www.w3.org/2000/svg', 'g') : document.createElement('div');

      this.state = {};
      this.state.props = createPropsStream(this.untouchedAttributes);
      this.state.childTree = undefined;

      var component = this.name(this.state.props.stream);

      if (!component) throw new Error('Component ' + this.name.name + ' must return a stream!');

      var stream = typeof component === 'function' ? component(context) : component;

      this.state.subscription = stream.pipe(flatten, operators.sample(sharedRaf)).subscribe({
        next: function next(newChildTree) {
          if (newChildTree instanceof VPatch) {
            _this.state.childTree = newChildTree.vTree;
          } else {
            node = patch(node, _this.state.childTree, newChildTree, isSvg);
            _this.state.childTree = newChildTree;
          }
        },
        error: function error(e) {
          return console.error(e);
        }
      });

      return node;
    }
  }, {
    key: 'updateElement',
    value: function updateElement(node, previousComponent, isSvg, patch, context) {
      this.state = previousComponent.state;

      if (previousComponent.name !== this.name) {
        previousComponent.removeElement(node);
        return this.createElement(isSvg, patch, context);
      } else {
        this.state.props.next(this.untouchedAttributes);
      }
    }
  }, {
    key: 'removeElement',
    value: function removeElement(node) {
      this.state.subscription.unsubscribe();
      if (this.state.childTree) this.state.childTree.removeElement(node);
    }
  }, {
    key: 'mount',
    value: function mount() {}
  }]);
  return Component;
}();

var flatMap = curry(function (f, xs) {
  return xs.reduce(function (acc, x) {
    return acc.concat(f(x));
  }, []);
});

function _objectEntries$1(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

function _objectEntries$1(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

var isLifecycle = function isLifecycle(key) {
  return ['mount', 'update', 'unmount'].includes(key);
};
var isEvent = function isEvent(key) {
  return !!key.match(/^on/);
};
var toEventName = function toEventName(key) {
  return key.replace(/^on/, '').toLowerCase();
};

var styleToObject = function styleToObject(styleStr) {
  return styleStr.split(';').reduce(function (acc, str) {
    var _str$split = str.split(/:/),
        _str$split2 = toArray(_str$split),
        k = _str$split2[0],
        v = _str$split2.slice(1);

    if (k.trim()) acc[k.trim()] = v.join(':');
    return acc;
  }, {});
};

var formatChildren = flatMap(function (c) {
  return Array.isArray(c) ? formatChildren(c) : [VNode, VText, VPatch, Component].some(function (C) {
    return c instanceof C;
  }) ? [c] : isEmpty(c) ? [] : [new VText({ text: '' + c })];
});

function h(name) {
  var attributes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var children = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  if (typeof name === 'function') {
    return new Component({
      name: name,
      untouchedAttributes: _extends({}, attributes, { children: children })
    });
  }

  var _Object$entries$reduc = _objectEntries$1(attributes).reduce(function (acc, _ref) {
    var _ref2 = slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    if (key === 'key') {
      acc.key = value;
    } else if (isLifecycle(key) && typeof value === 'function') {
      acc.lifecycle[key] = value;
    } else if (isEvent(key) && typeof value === 'function') {
      acc.events[toEventName(key)] = value;
    } else if (key === 'style') {
      acc.attrs[key] = (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' ? value : styleToObject(value);
    } else {
      acc.attrs[key] = value;
    }
    return acc;
  }, { lifecycle: createDefaultLifecycle(), events: {}, attrs: {} }),
      key = _Object$entries$reduc.key,
      lifecycle = _Object$entries$reduc.lifecycle,
      events = _Object$entries$reduc.events,
      attrs = _Object$entries$reduc.attrs;

  return new VNode({
    name: name,
    attrs: attrs,
    lifecycle: lifecycle,
    events: events,
    children: formatChildren(children),
    key: key
  });
}

var createRenderProcess = function createRenderProcess(vdom$) {
  return new rxjs.Observable(function (observer) {
    var domNode = void 0;
    var previousTree = void 0;
    var isSvg = void 0;

    return vdom$.subscribe({
      complete: function complete() {
        return observer.complete();
      },
      error: function error(e) {
        return observer.error(e);
      },
      next: function next(vTree) {
        if (!(vTree instanceof VNode)) return observer.next(vTree);

        var onMount = vTree.lifecycle.mount;

        vTree.lifecycle.mount = function (node, _isSvg) {
          domNode = node;
          isSvg = _isSvg;
          onMount(node);
        };

        if (!domNode) {
          observer.next(vTree);
        } else {
          domNode = patch(domNode, previousTree, vTree, isSvg);
          observer.next(new VPatch(vTree));
        }

        previousTree = vTree;
      }
    });
  });
};

var toRenderProcess = function toRenderProcess(tag) {
  return function (strings) {
    for (var _len = arguments.length, variables = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      variables[_key - 1] = arguments[_key];
    }

    return createRenderProcess(tag.apply(undefined, [strings].concat(variables)));
  };
};

// html :: [String] -> ...[Variable a] -> Observable VirtualDOM
var html$1 = toRenderProcess(createReactiveTag(createTag(h)));

// render :: Observable VirtualDOM -> DOMElement -> Promise Error ()
var render = function render(component, element, context) {
  var rootNode = element.firstChild;
  var previousTree = void 0;

  return component.subscribe({
    next: function next(vTree) {
      if (vTree instanceof VPatch) {
        previousTree = vTree.vTree;
      } else {
        if (!rootNode) {
          rootNode = vTree.createElement(false, patch, context);
          element.appendChild(rootNode);
        } else {
          patch(rootNode, previousTree, vTree, false, context);
        }
        previousTree = vTree;
      }
    }
  });
};

// textTag :: [String] -> ...[a] -> String
var textTag = function textTag(strings) {
  for (var _len = arguments.length, variables = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    variables[_key - 1] = arguments[_key];
  }

  return strings.reduce(function (acc, s, i) {
    return acc + s + (variables[i] !== undefined ? variables[i] : '');
  }, '');
};

// text :: [String] -> ...[Variable a] -> Observable String
var text = createReactiveTag(textTag);

exports['default'] = html$1;
exports.text = text;
exports.render = render;
